#coding:utf8
#author:zhoujingjiang
#date:2013-8-26

import sys

class CHECK_RUN_OVER(object):
    __ID_FRAME_MAPPING_DICT = {}
    ThreadSafety = False #非线程安全的

    def __call__(self, identify):
        caller_frame = sys._getframe().f_back
        identify = '%s.%s' % (caller_frame.f_code.co_name, identify)
        cur_frame = self.__class__.__ID_FRAME_MAPPING_DICT.get(identify)

        if not cur_frame or (ord(cur_frame.f_code.co_code[cur_frame.f_lasti]) == 83):
            self.__class__.__ID_FRAME_MAPPING_DICT[identify] = caller_frame
            return False
        return True

check_run_over = CHECK_RUN_OVER() #单例

